/* inputdialog.h
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023, 2024 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#ifndef N96_DRAW_inputdialog_h
#define N96_DRAW_inputdialog_h

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "commongui.h"
typedef struct InputDialogResponse {
	_Bool ok;
	char * name;
} InputDialogResponse;

typedef struct InputDialog {
	GtkEntry *entry_name;
	GtkLabel *lbl_name;
	GtkBox *hbx_name;
	GtkBox *vbx_main;
	GtkDialog *dlg;
} InputDialog;

void input_dialog_response_construct(InputDialogResponse *this, _Bool ok, char * name);
void input_dialog_response_destruct(InputDialogResponse *this);
void input_dialog_construct(InputDialog *this, GtkWindow *parent, const char * title, const char * label);
void input_dialog_destruct(InputDialog *this);
InputDialogResponse * input_dialog_run(InputDialog *this);

#endif /* N96_DRAW_inputdialog_h */
